/////////////////////////////////////////////////////////////////////////////////////////////+
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
//|                                                                      hTradeServFuncs.mq4 |
//|                                               Copyright  2009, VladVG, VladislavVG (VG) |
//|                                                                           4vg AT mail.ru |
//+------------------------------------------------------------------------------------------+
//===========================================================================================+
/////////////////////////////////////////////////////////////////////////////////////////////+
#property copyright "Copyright  2009, VladVG, VladislavVG (VG)"
#property link      "4vg AT mail.ru"

/////////////////////////////////////////////////////////////////////////////////////////////+
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
//|                  Include Files Section                                                   |
//+------------------------------------------------------------------------------------------+
//===========================================================================================+
/////////////////////////////////////////////////////////////////////////////////////////////+
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>
#include <vgTALib.mqh>

/////////////////////////////////////////////////////////////////////////////////////////////+
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
//|                  Service Variables Definition Block                                      |
//+------------------------------------------------------------------------------------------+
//===========================================================================================+
/////////////////////////////////////////////////////////////////////////////////////////////+

double        Leverage=0;
double        mnLotSz = 0;
double        mxLotSz = 0;
double        mnLotStp = 0;
int           nLotsDigits = 0;
int           ea_symbCnt = 1;
double        spread = 0;
string        nSYMBOL  = "";
double        nPoint = 0.0001;
int p1_Pnt    = 1;
int           minOrdPoint   = 0;
double        minOrdDist    = 0;//minOrdPoint*Point;
double        NationalAmount= 0;

#define RESCANSERVERS_COMMAND_CODE   37400
#define OPENLOGINWINDOW_COMMAND_CODE 35429
#define PAUSE 1000

/////////////////////////////////////////////////////////////////////////////////////////////+
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
//|                  Service functions codes                                                 |
//+------------------------------------------------------------------------------------------+
//===========================================================================================+
/////////////////////////////////////////////////////////////////////////////////////////////+

string GetFullFileName(string DISK, string PATH, string FName, string FEXT)
{
string rString = "";
    if(DISK !="") rString = rString + DISK + ":" + "\\"; //StringConcatenate(rString,DISK,":\\");
    if(PATH !="") rString = rString + PATH + "\\";
    if(FName!="") rString = rString + FName + ".";
    if(FEXT !="") rString = rString + FEXT;
    return(rString);
}

int ReScanServers()
{
int hwindow=GetAncestor(WindowHandle(Symbol(),Period()),2);   // Get Main MT Handle
   if(hwindow!=0) 
   {                                                          // If Exist
      return(PostMessageA(hwindow,WM_COMMAND,RESCANSERVERS_COMMAND_CODE,0)); // Send ReScan Servers Command
   }
   return(-1);
}

int ReLoginAccount()
{
int hwnd=GetAncestor(WindowHandle(Symbol(),Period()),2);           // Get Main MT Handle
   PostMessageA(hwnd,WM_COMMAND,OPENLOGINWINDOW_COMMAND_CODE,0);   // Open Login Window
   Sleep(PAUSE);
   hwnd=GetLastActivePopup(hwnd);                       // Finde Login Window Handle
   hwnd=GetDlgItem(hwnd,0x1);                           // Finde Login Button window handle
   Sleep(PAUSE);
   SendMessageA(hwnd,BM_CLICK,0,0);                     // Press Login button 
   return(0);
}


/// Global variables initialization
int initGVars(string symbol)
{

    nSYMBOL  = symbol;
    nPoint   = GetStdPointSize(nSYMBOL);
    Leverage       = AccountLeverage();
    NationalAmount = MarketInfo(nSYMBOL,MODE_LOTSIZE);
    mnLotSz        = MarketInfo(nSYMBOL,MODE_MINLOT);
    mxLotSz        = MarketInfo(nSYMBOL,MODE_MAXLOT);
    mnLotStp       = MarketInfo(nSYMBOL,MODE_LOTSTEP);
    minOrdPoint    = MathCeil(MarketInfo(nSYMBOL,MODE_STOPLEVEL));
    minOrdPoint    = MathCeil(MarketInfo(nSYMBOL,MODE_STOPLEVEL));
    minOrdDist     = minOrdPoint*Point;
    //nLotsDigits    = MathCeil(MathAbs(MathLog(mnLotSz)/MathLog(10)));
    nLotsDigits    = vgfGetDigitsAf(mnLotSz);
    spread         = MarketInfo(nSYMBOL,MODE_SPREAD);
    ea_symbCnt     = CheckEASymbolCnt();
    Print("mnLotSz  = ", DoubleToStr(mnLotSz,5)," mxLotSz  = ", mxLotSz," mnLotStp = ", mnLotStp," nLotsDigits = ",nLotsDigits);
    //for(int i=MxBARSHist-1;i>0;i--) Sig2Enter[i]=0.0;
    //int p1_Pnt = (int)MathCeil(1.0/nPoint);
    int p1_Pnt = 1.0/nPoint;
    Print("nPoint = ",nPoint," nLotsDigits = ",nLotsDigits," p1_Pnt = ",p1_Pnt );
    return(0);
}

int CheckEASymbolCnt()
{
   return(1);
}

void InitMarketInfoVars(string symbol)
{
/*
static bool InitedFlag   = false;
   if(symb!=symbol) InitedFlag = false;
   if(InitedFlag) return;
*/
    initGVars(symbol);
/*
   if(IsTesting())
        MinLotSize = 1.0;
   else MinLotSize = MarketInfo(symb,MODE_MINLOT);
*/

   //InitedFlag     = true;
   //Print("InitMarketInfoVars:=> NationalAmount = ",NationalAmount);
   //Print("InitMarketInfoVars:=> Finish!");
   }
   

///      prefix
int deleteObjectsByPrefix(string prefix)
{
	int obj_total = ObjectsTotal();
	string name="";
	
	int count = 0;
	for (int i = obj_total - 1; i >= 0; i--)
	{
		name = ObjectName(i);
		if (StringFind(name, prefix) != -1)
		{
			ObjectDelete(name);
			count++;
		}			
	}
	return(count);
}

double GetStdPointSize(string SMBL, double CostOfStdPoint = 10.0)
{
    //return( CostOfPoint/MarketInfo(SMBL,MODE_LOTSIZE) );
    //Print("SMBL = ",SMBL);
    if (StringFind(SMBL, "JPY") != -1) return(0.01);
    if (StringFind(SMBL, "HUF") != -1) return(0.01);
    if (StringFind(SMBL, "XAU") != -1) return(0.1);
    return(0.0001);
}

////////////////////////////////////////////////////////////////////////////////////////
//
//
//
////////////////////////////////////////////////////////////////////////////////////////

double GetMaxRichedBallance()
{
//   if(TrassertFunction) Print(" GetMaxRichedBallance() Start !");

int    total      = OrdersHistoryTotal();
double max_acc_Ballance = 0;
double cur_ordBallance = 0;
   for(int cnt=0;cnt<total;cnt++) {
       if(OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY)){
          cur_ordBallance += OrderProfit();
          if(max_acc_Ballance<cur_ordBallance) max_acc_Ballance = cur_ordBallance;
          }
       }//for( cnt=0;cnt<total;cnt++) {
//   if(TrassertFunction) Print(" GetMaxRichedBallance() Finish !");
   return(max_acc_Ballance);
   }


double GetTodayProfit()
{
//   if(TrassertFunction) Print(" GetTodayProfit() Start !");

int    total = OrdersHistoryTotal();
double cur_ordBallance = 0.0;
//int ordcnt=0;
   for(int cnt=0;cnt<total;cnt++) {
       if(OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY)){
          if(  (TimeDay(OrderCloseTime())  ==TimeDay(  Time[0]))
             &&(TimeMonth(OrderCloseTime())==TimeMonth(Time[0]))
             &&(TimeYear(OrderCloseTime()) ==TimeYear( Time[0]))
             ){
             //ordcnt++;
             cur_ordBallance += OrderProfit();
             }
          }
       }//for( cnt=0;cnt<total;cnt++) {
//   if(TrassertFunction) Print(" GetTodayProfit() Finish !");
   //Print("   ",ordcnt," ");
   return(cur_ordBallance);
   }
///////////////////////////////////////////////////////////////////////////////////////////

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
int GetLastLossesOrdsCnt()
{
int    orders = OrdersHistoryTotal(); 
int    losses = 0;
   for(int i=orders-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
      //----
      if(OrderProfit()>0) break;
      if(OrderProfit()<0) losses++;
      }
   return(losses);
   }
   
double GetMaxHistoryLots(string symbol, int MAGICK)
{
double lastTradelots = -1,cur_Tradelots=-1;   
int    cur_ordoptime=0, max_ordoptime=0;
int    orders = OrdersHistoryTotal(); 
   for( int i=orders-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) 
      { 
         Print("Error in history!"); 
         break; 
         }
      if( (OrderSymbol()!=symbol)
        ||(OrderType()>OP_SELL)
        ||(OrderMagicNumber()!=MAGICK)
        ) continue;
      cur_ordoptime = OrderOpenTime();
      if(cur_ordoptime > max_ordoptime)
      {
         cur_ordoptime = max_ordoptime;
         cur_Tradelots = OrderLots();
         if(lastTradelots < cur_Tradelots) lastTradelots = cur_Tradelots;
         }
      }//for( cnt=0;cnt<total;cnt++) {
   return(lastTradelots);
   }

////////////////////////////////////////////////////////////////////////////////////////
// 4 Fixed Proportional Metod
//=========================================================
double Delta = 0, StartDelta = 3000.0, StartBalance=0;  // /     +/- 1
double NewLotsLevel  = 0.0;
double PrevLotsLevel = 0.0;
double nLots = 0.0,  dLots=0.0;
////////////////////////////////////////////////////////////////////////////////////////
//   -   ,    
#define MMng_MAXHIST 0
//   ,  . 
//      (fixlot>0) -   
//    -    (  Risk)
#define MMng_FIXRL   1
//          
#define MMng_DECRS   2
// -  -    -  
//   
#define MMng_FIXPROP 3


double  CulcOpnVolumeSize(string symbol, int MAGICK=0, int ManyMngType = 0,
                   double Risk = 0.1, double minRisk = 0.1, double maxRisk = 0.3, 
                   string dirctn = "SHRT", double DecreaseFactor=0, double fixlot = 0, bool inLotsCount = true
                   )
{
   //if(TrassertFunction|| TrassertGetLots) Print(" GetLots() Start !");
   InitMarketInfoVars(symbol);
double lots    = 0.0;
double retlot  = 0;
int    lossesordscnt = 0;
double retLots = 0.0;
//double std_Lsz   = NationalAmount/CostOfNAPoint(symbol,dirctn);
//double nlotsPerNA= NationalAmount/Leverage;
   // Print(" GetLots(): 1 stdlotsize = ",stdlotsize);
    //if(stdlotsize == 0) stdlotsize = STDLOTSIZE;
    //Print(" GetLots(): stdlotsize = ",stdlotsize);
/*
double mxSz    = FreeMargin/ea_symbCnt;//MathMin(AccountBalance(),AccountEquity());
double pSz     = mxSz*Leverage/NationalAmount;
double MaxUpLotsCount = NormalizeDouble(pSz/Ask,nLotsDigits);
double MaxDnLotsCount = NormalizeDouble(pSz/Bid,nLotsDigits);
*/
   //Print(" GetLots(): 1 ea_symbCnt = ",ea_symbCnt);
   //Print(" GetLots(): 1 NationalAmount = ",NationalAmount);
double FreeMargin = AccountFreeMargin();
double mxaddSz = FreeMargin/ea_symbCnt;
double paddSz  = mxaddSz*Leverage/NationalAmount;
double MaxaddUpLotsCount = NormalizeDouble(paddSz/Ask,nLotsDigits);
double MaxaddDnLotsCount = NormalizeDouble(paddSz/Bid,nLotsDigits);
    
   if(dirctn == "SHRT")
   {
       lots = NormalizeDouble(MaxaddDnLotsCount*Risk,nLotsDigits);
   }
   if(dirctn == "LONG")
   {
       lots = NormalizeDouble(MaxaddUpLotsCount*Risk,nLotsDigits);
   }
double MAX_addLots = lots;
   //Print(" GetLots(): 1 lots = ",lots);
   //
   switch(ManyMngType)
   {
      case  MMng_FIXRL:
            if(fixlot>0) 
                 retLots = fixlot;
            else if(Risk>0) retLots = lots;
                 else 
                 {
                    Print("Parameters Error : Risk = ", Risk," fixlot = ",fixlot);
                    return(-1);//   
                    }
            break;
      case  MMng_DECRS:
            lossesordscnt = GetLastLossesOrdsCnt();
            if(lossesordscnt>1) 
                 retlot = NormalizeDouble(lots-lots*lossesordscnt/DecreaseFactor,nLotsDigits);
            else retlot = lots;
            break;
      
      case  MMng_FIXPROP:
            double AccBalance = AccountBalance();
            if(StartBalance<mnLotSz) StartBalance = AccBalance;
            if(dLots<mnLotSz) dLots = MathMax(mnLotSz,0.01*StartBalance);
            if(nLots<mnLotSz) nLots = lots;
            Delta = MathMin( 0.5*StartBalance,StartDelta);
            if(PrevLotsLevel<mnLotSz) PrevLotsLevel = StartBalance;       
            if(NewLotsLevel<mnLotSz)  NewLotsLevel  = PrevLotsLevel + (nLots*Delta);            

            if(AccBalance < PrevLotsLevel)
            {
               nLots = nLots - 0.5*dLots;
               PrevLotsLevel = AccBalance;
               NewLotsLevel  = PrevLotsLevel + (nLots*Delta);
               }
            else if(AccBalance >= NewLotsLevel)
                 {
                    nLots = nLots + dLots;
                    PrevLotsLevel = NewLotsLevel;
                    NewLotsLevel  = PrevLotsLevel + (nLots*Delta);
                    }
            retLots = nLots;
            break;
      case  MMng_MAXHIST:
      default           :
            retLots = MathMax(lots,GetMaxHistoryLots(symbol, MAGICK));
            break;
      }

   //if(Risk==maxRisk) lastTradelots = GetMaxHistoryLots(string symbol, int MAGICK);
    
   //Print("1 GetLots: lots = ",lots, " lastTradelots = ",lastTradelots, " retLots = ",retLots);
   
   //Print("2 GetLots: lots = ",lots, " lastTradelots = ",lastTradelots, " retLots = ",retLots);
   //if(TrassertFunction) Print(" GetLots() Finish !");
   //if((retLots<mnLotSz)&&(Risk!=0))retLots = mnLotSz;
   //if(retLots>mxLotSz)retLots = mxLotSz;
//---- return lot size
   double minL = MarketInfo(Symbol(),MODE_MINLOT);
   double maxL = MarketInfo(Symbol(),MODE_MAXLOT);
   //lot = 1;
   //Comment("retlot = ",retlot," minL = ", minL," maxL = ", maxL," MAX_addLots = ", MAX_addLots);
 //  if((retlot>0)&&(retlot<minL)&&(MAX_addLots>minL)) retlot = minL;
 //  if((retlot>0)&&(retlot<minL)&&(MAX_addLots<minL)) retlot = 0;
   if((retlot>0)&&(retlot<minL)&&(MAX_addLots>minL))
   { // Is Depo Inaf to open minSize ?
       if( ( AccountFreeMarginCheck( nSYMBOL, OP_BUY,  mnLotSz ) < 10. ) || 
           ( AccountFreeMarginCheck( nSYMBOL, OP_SELL, mnLotSz ) < 10. ) || 
           ( GetLastError() == ERR_NOT_ENOUGH_MONEY ) )
                  retlot = 0.0;         // No
       else       retlot = minL;        // Yes
       //retLots = mnLotSz;
   }
   if(retlot>maxL) retlot=maxL;
   
   return(retlot);



   if(!inLotsCount) retLots*=NationalAmount;
   return(retLots);
}
   /*
double LotsOptimized()
  {
   double addLots=0;
   int    orders = OrdersHistoryTotal();     // history orders total
   int    losses=0;                          // number of losses orders without a break
//---- select lot size
   double mxSz        = MathMin(AccountBalance(),AccountEquity())/ea_symbCnt;
   double mxaddSz     = AccountFreeMargin()/ea_symbCnt;
   double pSz         = mxSz*Leverage/NationalAmount;    // 
   double paddSz      = mxaddSz*Leverage/NationalAmount; // 
   double MAX_Lots    = NormalizeDouble(pSz*MaximumRisk,nLotsDigits);
   double MAX_addLots = NormalizeDouble(paddSz*MaximumRisk,nLotsDigits);
   double lot         = NormalizeDouble(MathMin(MAX_Lots,MAX_addLots),nLotsDigits);
   double retlot      = 0;
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=nSYMBOL || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) retlot=NormalizeDouble(lot-lot*losses/DecreaseFactor,nLotsDigits);
     }
   else {
      double lastTradelots = 0, cur_Tradelots = 0;   
      int    cur_ordoptime=0, max_ordoptime=0;
      for( i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         cur_ordoptime = OrderOpenTime();
         //Print("GetLots OrdSymbol = ",Symbol(),"cur_ordoptime = ",cur_ordoptime);
         if(cur_ordoptime > max_ordoptime){
            cur_ordoptime = max_ordoptime;
            cur_Tradelots = OrderLots();
            if(lastTradelots < cur_Tradelots) lastTradelots = cur_Tradelots;
            }        
         }
     retlot = MathMax(lot,lastTradelots);
     }//else

//---- return lot size
   double minL = MarketInfo(Symbol(),MODE_MINLOT);
   double maxL = MarketInfo(Symbol(),MODE_MAXLOT);
   //lot = 1;
   //Comment("retlot = ",retlot," minL = ", minL," maxL = ", maxL," MAX_addLots = ", MAX_addLots);
 //  if((retlot>0)&&(retlot<minL)&&(MAX_addLots>minL)) retlot = minL;
 //  if((retlot>0)&&(retlot<minL)&&(MAX_addLots<minL)) retlot = 0;
   if((retlot>0)&&(retlot<minL)&&(MAX_addLots>minL))
   { // Is Depo Inaf to open minSize ?
       if( ( AccountFreeMarginCheck( SYMBL, OP_BUY,  mnLotSz ) < 10. ) || 
           ( AccountFreeMarginCheck( SYMBL, OP_SELL, mnLotSz ) < 10. ) || 
           ( GetLastError() == ERR_NOT_ENOUGH_MONEY ) )
                  retlot = 0.0;         // No
       else       retlot = minL;  // Yes
       //retLots = mnLotSz;
   }
   if(retlot>maxL) retlot=maxL;
   
   return(retlot);
  }
*/
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
#define BUY_MRKT 0
#define SLL_MRKT 1
#define BUY_LIMT 2
#define SLL_LIMT 3
#define BUY_STOP 4
#define SLL_STOP 5

int GetTradeOrdersCount(int &ordTp[], string symbol, int MAGICMA=0)
{
int mode = 0, totalOrds=0;
//----
    for(int ot=0;ot<=SLL_STOP;ot++)
        ordTp[ot]=0;
    for(int i=OrdersTotal()-1;i>=0;i--)
    {
        if( !OrderSelect(i,SELECT_BY_POS,MODE_TRADES) ) break;    // No more Orders
        if(OrderSymbol()!=symbol) continue;                       // Wrong Symbol
        if((MAGICMA!=0)&&(OrderMagicNumber()!=MAGICMA)) continue; // Wrong Expert ORE Manual Order
        mode = OrderType();
        switch(mode)
        {
            case OP_BUY      : ordTp[BUY_MRKT]++; break;
            case OP_SELL     : ordTp[SLL_MRKT]++; break;
            case OP_BUYLIMIT : ordTp[BUY_LIMT]++; break;
            case OP_SELLLIMIT: ordTp[SLL_LIMT]++; break;
            case OP_BUYSTOP  : ordTp[BUY_STOP]++; break;
            case OP_SELLSTOP : ordTp[SLL_STOP]++; break;
            default          : return(-1); break; // Wrong Order Type
        }
        totalOrds++;
    }
//---- return orders volume
   return(totalOrds);
}
  
/////////////////////////////////////////////////////////////////////////////////////////////+
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
//|
//+------------------------------------------------------------------------------------------+
//===========================================================================================+
/////////////////////////////////////////////////////////////////////////////////////////////+
#define MAXCYKLESCNT 20

int ErrReaction(int err)
{
    switch(err)
    {
        case ERR_INVALID_STOPS : 
        case ERR_INVALID_TRADE_VOLUME : 
        case ERR_MARKET_CLOSED : 
        case ERR_TRADE_DISABLED : 
        case ERR_NOT_ENOUGH_MONEY : 
                 return(-1);
        case ERR_PRICE_CHANGED : 
        case ERR_OFF_QUOTES : 
        case ERR_REQUOTE : 
                 RefreshRates();
                 break;
        case ERR_BROKER_BUSY : 
        case ERR_TRADE_CONTEXT_BUSY : 
                 while(!IsTradeAllowed()) Sleep(500);
                 RefreshRates();
                 break;
        case ERR_NO_CONNECTION :
                 ReScanServers();
                 RefreshRates();
        default : break;
    }//switch(err)
    return(0);
}//int ErrReaction(int err)
/////////////////////////////////////////////////////////////////////////////////////////////+
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
//|
//+------------------------------------------------------------------------------------------+
//===========================================================================================+
/////////////////////////////////////////////////////////////////////////////////////////////+
int slp = 3;
int ChangeOrderStopLoss( int  ticket, string ordt, double NewStopLoss = 0.0, int ModifyColor = White )
{
Print("Ord Tiket = ",ticket);
int  err    = GetLastError(), err_res = 0;
bool ordres = OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
    if(!ordres)
    {
        err     = GetLastError();
        err_res = ErrReaction(err); 
        Print("OrdSelect Err(",err,") of ordtiket ",ticket,": ",ErrorDescription(err)); 
        if(err_res<0) return(err_res);
    }
double NSL   = NormalizeDouble(NewStopLoss,    Digits);
double ordSL = NormalizeDouble(OrderStopLoss(),Digits);

    if(ordSL==NSL) return(0);
//Print(" NSL   = ",NSL," Ord SL   = ",ordSL);    
int    ordtype  = OrderType();
//Print(" (Bid-NSL)   = ",(Bid-NSL)," (minOrdDist+slp*Point)   = ",(minOrdDist+slp*Point)); 
//Print(" (NSL-Ask)   = ",(NSL-Ask)," (minOrdDist+slp*Point)   = ",(minOrdDist+slp*Point)); 
//if(!((ordtype==OP_BUY)&&((Bid-NSL)>(minOrdDist+slp*Point)) )) return(0);
//if(!((ordtype==OP_SELL)&&((NSL-Ask)>(minOrdDist+slp*Point)) )) return(0);
if(ordtype==OP_BUY)
{
    if((Bid-NSL)<(minOrdDist+slp*Point)) return(0);
    if(ordSL>NSL) return(0);
}

if(ordtype==OP_SELL)
{
    if(ordSL!=0)
    {
         if((NSL-Ask)<(minOrdDist+slp*Point)) return(0);
         if(ordSL<NSL) return(0);
    }
}
//Print("Ok ! ===> ");
double price    = 0.0;
     switch(ordtype)
     {
         case OP_BUY  : price = NormalizeDouble(Bid,Digits); break;
         case OP_SELL : price = NormalizeDouble(Ask,Digits); break;
     }

bool res    = false;
int  ncykls =     0;

    while((!res)&&(ncykls<MAXCYKLESCNT))
    {
        while(!IsTradeAllowed()) Sleep(500);
        RefreshRates();
        res = OrderModify(ticket,OrderOpenPrice(),NSL,OrderTakeProfit(),OrderExpiration(),ModifyColor);
        if(!res)
        { 
            ncykls++;
            err=GetLastError();
            err_res = ErrReaction(err); 
            Print(ncykls," Err(",err,") change SL of ",ordt,": ",ErrorDescription(err)); 
            Print(ncykls," Ord SL = ",ordSL," NewSL =  ",NSL); 
            if(err_res<0) return(err_res);
        } 
    }//while((!res)&&(ncykls<MAXCYKLESCNT))
    return(0);
}//ChangeOrderStopLoss(.....)

int ChangeOrderTakeProfit( int ticket, string ordt = "", double NewTakeProfit = 0.0, int ModifyColor = White )
{
int  err    = GetLastError(), err_res = 0;
bool ordres = OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
    if(!ordres)
    {
        err     = GetLastError();
        err_res = ErrReaction(err); 
        Print("OrdSelect Err(",err,") of ordtiket ",ticket,": ",ErrorDescription(err)); 
        if(err_res<0) return(err_res);
    }
double NTP   = NormalizeDouble(NewTakeProfit,  Digits);
double ordTP = NormalizeDouble(OrderTakeProfit(),Digits);
    if(ordTP==NTP) return(0);

int    ordtype  = OrderType();

//if(!((ordtype==OP_BUY) &&((NTP-Ask)>(minOrdDist+slp*Point)) )) return(0);
//if(!((ordtype==OP_SELL)&&((Bid-NTP)>(minOrdDist+slp*Point)) )) return(0);

if(ordtype==OP_BUY)
{
    if((NTP-Ask)<(minOrdDist+slp*Point)) return(0);
    //if(ordSL>NSL) return(0);
}

if(ordtype==OP_SELL)
{
    if((Bid-NTP)<(minOrdDist+slp*Point)) return(0);
    //if(ordSL<NSL) return(0);
}

double price    = 0.0;
     switch(ordtype)
     {
         case OP_BUY  : price = NormalizeDouble(Bid,Digits); break;
         case OP_SELL : price = NormalizeDouble(Ask,Digits); break;
     }

bool res = false;
int  ncykls = 0;
    while((!res)&&(ncykls<MAXCYKLESCNT))
    {
        while(!IsTradeAllowed()) Sleep(500);
        RefreshRates();
        res = OrderModify(ticket,OrderOpenPrice(),OrderStopLoss(),NTP,OrderExpiration(),ModifyColor);
        if(!res)
        { 
            ncykls++;
            err=GetLastError(); 
            err_res = ErrReaction(err);
            Print(ncykls," Err(",err,") change TP of ",ordt,": ",ErrorDescription(err)); 
            Print(ncykls," Ord TP = ",ordTP," NewTP =  ",NTP); 
            if(err_res<0) return(err_res);
        } 
    }//while((!res)&&(ncykls<MAXCYKLESCNT))
    return(0);
}//ChangeOrderStopLoss(.....)

int SetMarketOrder( string symbol,   int cmd, 
                    double volume,   double price,          int  slippage, 
                    double stoploss, double takeprofit,     string comment="", 
                    int magic=0,     datetime expiration=0, color arrow_color=CLR_NONE
                    )
{
Print("SetMarketOrder() SL = ",stoploss, "TP = ",takeprofit);
int    err = GetLastError();
int    ticket = -1,ncykls=0;
double ordprice = 0;   
string ordt = "";
color  ordc = CLR_NONE;
double op_v = NormalizeDouble(volume,nLotsDigits);
//double op_p = NormalizeDouble(price,Digits);
double op_s = NormalizeDouble(stoploss,Digits);
double op_t = NormalizeDouble(takeprofit,Digits);
   while((ticket<0)&&(ncykls<MAXCYKLESCNT))
   {
      while(!IsTradeAllowed()) Sleep(500);
      RefreshRates();
      switch(cmd)
      {
         case OP_BUY : 
             ordprice = NormalizeDouble(Ask, Digits); 
             ordt     = " Long (BUY) "; 
             ordc     = Blue; 
             break;
         case OP_SELL: 
             ordprice = NormalizeDouble(Bid, Digits); 
             ordt     = " Short (SELL) ";
             ordc     = Red; 
             break;
         default : return(-1);
         }

      //ticket=OrderSend(symbol,cmd,op_v,ordprice,slippage,op_s,op_t,comment,magic,expiration,arrow_color);
      ticket=OrderSend(symbol,cmd,op_v,ordprice,slippage,0,0,comment,magic,expiration,arrow_color);
      if(ticket<0)
      {
         ncykls++;
         err = GetLastError();
         int err_res = ErrReaction(err);
         Print(ncykls," ",ordt," MrktOrderSend failed.");
         Print("Error(",err,"): ",ErrorDescription(err));
         Print("Ord Params are : volume = ", op_v, " price = ",ordprice," slippage = ", slippage,
               " stoploss = ",op_s," takeprofit = ",op_t
               );
         if(err_res<0) return(err_res);
      }//if(ticket<0)
      else
      { 
          if(stoploss!=0)
              ChangeOrderStopLoss(   ticket, ordt, stoploss,   ordc );
          if(takeprofit!=0)
              ChangeOrderTakeProfit( ticket, ordt, takeprofit, ordc );
          return(ticket);
      }//else
   }//while((ticket<0)&&(ncykls<MAXCYKLESCNT))
   return(ticket);
}//int SetMarketOrder(....)

int ChangeOrdersTakeProfit(string symbol, int MAGIC, int OrdType, double NewTakeProfit = 0.0,  int ModifyColor = White )
{
double price=0;
string ordt = "";
double NTP = NormalizeDouble(NewTakeProfit,Digits);
   switch(OrdType)
   {
      case OP_BUY      : ordt = " Long (BUY) ";  break;
      case OP_SELL     : ordt = " Short (SELL) ";break;
      case OP_BUYLIMIT : ordt = " Long (BUY) Limit ";  break;
      case OP_BUYSTOP  : ordt = " Long (BUY) Stop  ";  break;
      case OP_SELLLIMIT: ordt = " Short (SELL) Limit ";break;
      case OP_SELLSTOP : ordt = " Short (SELL) Stop  ";break;
      default : return(0);
      }
bool res    = false;
int  total  = OrdersTotal(), 
     type   = 0,
     ncykls = 0,
     error  = GetLastError(); 

   Print("ChOTP(): OrdType = ",ordt," NewTakeProfit = ",NewTakeProfit);
   for(int i=total-1;i>=0;i--)
   {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
      if(OrderMagicNumber()!=MAGIC || OrderSymbol()!=symbol) continue;
      type = OrderType();
      if(type!=OrdType) continue;
      price = NormalizeDouble(OrderTakeProfit(),Digits);
      if(price==NTP) continue;
      while((!res)&&(ncykls<MAXCYKLESCNT))
      {
         while(!IsTradeAllowed()) Sleep(500);
         RefreshRates();
         res = OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NTP,OrderExpiration(),ModifyColor);
         if(!res)
         { 
            ncykls++;
            error=GetLastError();
            int err_res = ErrReaction(error);
            Print(ncykls," Err(",error,") change TP  of ",ordt,": ",ErrorDescription(error)); 
            Print(ncykls," Ord TP = ",price," NewTP =  ",NTP); 
            if(err_res<0) return(err_res);
            }
         }//while((!res)&&(ncykls<MAXCYKLESCNT))
      }//for(int i=0;i<total;i++)
   return(0);
   }

int ChangeOrdersStopLoss(string symbol, int MAGIC, int OrdType, double NewStopLoss = 0.0,  int ModifyColor = White )
{
double price=0;
double ord_pft=0;
double ord_sl=0;
string ordt = "";
double NSL = NormalizeDouble(NewStopLoss,  Digits);
   
   //if((cmd==OP_BUY)&&((Bid-stoploss)>(minOrdDist+slp*Point)) )
   
   switch(OrdType)
   {
      case OP_BUY      : ordt = " Long (BUY) ";  break;
      case OP_SELL     : ordt = " Short (SELL) ";break;
      case OP_BUYLIMIT : ordt = " Long (BUY) Limit ";  break;
      case OP_BUYSTOP  : ordt = " Long (BUY) Stop  ";  break;
      case OP_SELLLIMIT: ordt = " Short (SELL) Limit ";break;
      case OP_SELLSTOP : ordt = " Short (SELL) Stop  ";break;
      default : return(0);
      }

bool res    = false;
bool slmoov = false;
int  total  = OrdersTotal(), 
     type   = 0,
     ncykls = 0,
     error  = GetLastError(); 

   for(int i=total-1;i>=0;i--)
   {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
      if(OrderMagicNumber()!=MAGIC || OrderSymbol()!=symbol) continue;
      type = OrderType();
      if(type!=OrdType) continue;
      price = NormalizeDouble(OrderStopLoss(),Digits);
      if(price==NSL) continue;
      ord_pft = OrderProfit();
      if(ord_pft>0)
      {
         if((type==OP_BUY) &&(NSL>price+Point))slmoov = true;
         else continue;
         if((type==OP_BUY) &&(NSL<price)) continue;
         if((type==OP_SELL)&&(NSL<price-Point))slmoov = true;
         else continue;
         if((type==OP_SELL)&&(NSL>price)) continue;
         }
      if(slmoov)
      {
         while((!res)&&(ncykls<MAXCYKLESCNT))
         {
            while(!IsTradeAllowed()) Sleep(500);
            RefreshRates();
            res = OrderModify(OrderTicket(),OrderOpenPrice(),NSL,OrderTakeProfit(),OrderExpiration(),ModifyColor);
            if(!res)
            { 
               ncykls++;
               error=GetLastError(); 
               int err_res = ErrReaction(error);
               Print(ncykls," Err(",error,") change SL of ",ordt,": ",ErrorDescription(error)); 
               Print(ncykls," Ord SL = ",price," NewSL =  ",NSL); 
               if(err_res<0) return(err_res);
               } 
            }//while((!res)&&(ncykls<MAXCYKLESCNT))
         }//if(slmoov)
      }//for(int i=0;i<total;i++)
   return(0);
   }



/////////////////////////////////////////////////////////////////////////////////////////////+
//===========================================================================================+
//+------------------------------------------------------------------------------------------+
//|                                                                                          |
//|  +++++++++++++++++++++++++++++++ End of codes. Regards ++++++++++++++++++++++++++++++++  |
//|                                                                                          |
//+------------------------------------------------------------------------------------------+
//===========================================================================================+
/////////////////////////////////////////////////////////////////////////////////////////////+